<HTML>
<HEAD>
<TITLE>Figure 14-2</TITLE>
</HEAD>
<BODY>
<?
   /*
   ** Quicksort
   ** input_array is an array of integers
   ** left is the leftmost element to be considered
   ** right is the rightmost element to be considered
   */
   function Quicksort(&$input_array, 
      $left_limit, $right_limit)
   {
      //start pointers
      $left = $left_limit;
      $right = $right_limit;

      //Choose the middle element for the pivot
      $pivot_point = intval(($left + $right)/2);
      $pivot = $input_array[$pivot_point];

      do
      {
         while(($input_array[$left] < $pivot) AND ($left < $right_limit))
         {
            $left++;
         }
         
         while(($pivot < $input_array[$right]) AND ($right > $left_limit))
         {
         	$right--;
         }
         
         if($left <= $right)
         {
         	//swap elements
         	$temp = $input_array[$left];
         	$input_array[$left] = $input_array[$right];
         	$input_array[$right] = $temp;
         	$left++;
         	$right--;
         }

      }
      while($left <= $right);

      if($left_limit < $right)
      {
         Quicksort(&$input_array, $left_limit, $right);
      }
      
      if($left < $right_limit)
      {
         Quicksort(&$input_array, $left, $right_limit);
      }
   }

   /*
   ** print text with an HTML line break
   */
   function println($text)
   {
      print("$text<BR>\n");
   }

   $some_numbers = array(6, 13, 99, 2, 33, 19, 84);

   //print array
   print("<H3>Unsorted</H3>\n");
   array_walk($some_numbers, "println");

   //sort array
   Quicksort(&$some_numbers, 0, count($some_numbers)-1);

   //print array again
   print("<H3>Sorted</H3>\n");
   array_walk($some_numbers, "println");

?>
</BODY>
</HTML>